
#define	bool	int
#define	true	1
#define	false	0

bool	ByteWaiting(int serialPort, int timeOut);
int	ReadBytes(int serialPort, unsigned char *bfr, int maxBytes, int timeOut);
void	WriteBytes(int serialPort, unsigned char *theBytes, int numBytes);
void	FlushBytes(int serialPort);
bool	ConfigureDevice(int serialPort, int baudRate, unsigned char dataBits, unsigned char stopBits, unsigned char parity, bool cooked);
void	GetDeviceConfiguration(int serialPort, int *baudRate, unsigned char *dataBits, unsigned char *stopBits, unsigned char *parity);
bool	ConfigureFlowControl(int serialPort, bool wantControl);
void	GetDeviceStatus(int serialPort, bool *CTS, bool *DCD);
void	SetDTR(int serialPort, bool DTR);
bool	OpenDevice(char *theName, int *serialPort);
void	CloseDevice(int serialPort);
