;
;  Z80 Disassembly of hdrs10m.com
;  02/11/04 21:18
; 
; Montezuma Micro 10MB hard disk driver
; for Model 4 CP/M
;
; Modified to ignore write protect status - 05/20/2004
;
	org	100h
;
X0100:	jp	start		; 0100  c3 a7 01	C'.
;
X0103:	db	'Copyright (c) (p) 1986 by Montez'	; 0103
	db	'uma Micro/JBO'				; 0123
	db	0dh,0ah					; 0130 ..
	db	'Driver HDRS10M V'			; 0132
X0142:	db	'ersion 1.10'				; 0142
	db	0dh,0ah					; 014d ..
	db	'$'					; 014f
X0150:	dw	132h		; 0150   32 01      2.
;
table:	db	wddata,4,92h,1,0,0,0,0			; 0152 H.......
	db	0,0,0,0,0,0,0,0				; 015a ........
	db	64h,2,99h,1,64h,2,99h,1			; 0162 d...d...
	db	0,0,0,0,0,0,0,0				; 016a ........
	db	64h,2,99h,1,32h,1,0a0h,1		; 0172 d...2. .
	db	32h,1,0a0h,1,0,0,0,0			; 017a 2. .....
	db	32h,1,0a0h,1,32h,1,0a0h,1		; 0182 2. .2. .
	db	32h,1,0a0h,1,32h,1,0a0h,1		; 018a 2. .2. .
	db	6,3fh,3,0ffh,3,0ffh,1,6			; 0192 .?......
	db	3fh,3,93h,3,0ffh,1,5,1fh		; 019a ?.......
	db	1,5fh,2,0ffh,0				; 01a2 ._...
;
start:	ld	de,X0103	; 01a7  11 03 01	...
	ld	c,9		; 01aa  0e 09		..
	ld	a,(dma)		; 01ac  3a 80 00	:..	; get trailer byte count
	or	a		; 01af  b7		7
	jp	z,X0005		; 01b0  ca 05 00	J..	; display msg if no options entered
	ld	sp,buffer	; 01b3  31 ea 12	1j.
	ld	hl,(X0001)	; 01b6  2a 01 00	*..	; get bios address
	ld	de,X15fd	; 01b9  11 fd 15	.}.	; add 5629 bytes
	add	hl,de		; 01bc  19		.	; test for available memory
	jr	c,start1	; 01bd  38 12		8.	; go if insufficient memory error
	ld	(biosend),hl	; 01bf  22 1f 12	"..	; else save memory pointer
	ex	de,hl		; 01c2  eb		k
	ld	hl,X00c0	; 01c3  21 c0 00	!@.	; add 192 extra bytes
	add	hl,de		; 01c6  19		.
	ld	(X1225),hl	; 01c7  22 25 12	"%.
	ex	de,hl		; 01ca  eb		k
	ld	de,X03ff	; 01cb  11 ff 03	...
	add	hl,de		; 01ce  19		.	; total of 6844 bytes added
	jr	nc,start2	; 01cf  30 06		0.	; go if ok
start1:	ld	hl,imemsg	; 01d1  21 d1 0d	!Q.	; else insufficient memory
	jp	done		; 01d4  c3 cf 0b	CO.
;
start2:	ld	hl,(X0001)	; 01d7  2a 01 00	*..	; get bios address
	ld	bc,X0018	; 01da  01 18 00	...	; point to seldsk vector
	add	hl,bc		; 01dd  09		.
	ld	de,seldsk	; 01de  11 88 0d	...
	ld	c,12h		; 01e1  0e 12		..	; transfer 18 bytes to bios vectors
	ldir			; 01e3  ed b0		m0
	ld	c,6		; 01e5  0e 06		..
	add	hl,bc		; 01e7  09		.	; point past sectran vector
	ld	de,X1252	; 01e8  11 52 12	.R.	; transfer special BIOS vectors
	ld	c,18h		; 01eb  0e 18		..
	ldir			; 01ed  ed b0		m0
	ld	hl,fcb0		; 01ef  21 05 0d	!..
	ld	de,X0d06	; 01f2  11 06 0d	...
	ld	c,1fh		; 01f5  0e 1f		..
	ld	(hl),0		; 01f7  36 00		6.	; clear scratchpad area
	ldir			; 01f9  ed b0		m0
	ld	c,18h		; 01fb  0e 18		..
	ld	hl,fcb0		; 01fd  21 05 0d	!..	; init stuff in scratchpad
	add	hl,bc		; 0200  09		.	; from special BIOS vectors
	ex	de,hl		; 0201  eb		k
	ld	hl,(X1256)	; 0202  2a 56 12	*V.
	add	hl,bc		; 0205  09		.
	ldi			; 0206  ed a0		m 
	ldi			; 0208  ed a0		m 
	ld	hl,(X1256)	; 020a  2a 56 12	*V.
	ld	e,(hl)		; 020d  5e		^
	inc	hl		; 020e  23		#
	ld	d,(hl)		; 020f  56		V
	ld	hl,X0008	; 0210  21 08 00	!..
	add	hl,de		; 0213  19		.
	ld	a,(hl)		; 0214  7e		~
	inc	hl		; 0215  23		#
	ld	h,(hl)		; 0216  66		f
	ld	l,a		; 0217  6f		o
	ld	(X0580),hl	; 0218  22 80 05	"..
	ld	(X0630),hl	; 021b  22 30 06	"0.
	ld	(X06e0),hl	; 021e  22 e0 06	"`.
	ld	(X0790),hl	; 0221  22 90 07	"..
	ld	a,(X1220)	; 0224  3a 20 12	: .
	ld	c,a		; 0227  4f		O
	ld	hl,(X1256)	; 0228  2a 56 12	*V.
	ld	b,10h		; 022b  06 10		..
start3:	inc	hl		; 022d  23		#
	ld	a,(hl)		; 022e  7e		~	; test first 16 bytes
	inc	hl		; 022f  23		#
	cp	c		; 0230  b9		9
	jr	nc,start4	; 0231  30 04		0.
	djnz	start3		; 0233  10 f8		.x
	jr	start5		; 0235  18 09		..
;
start4:	ld	hl,nonmsg	; 0237  21 01 0e	!..	; HD driver already installed
	call	print		; 023a  cd 9a 0d	M..
	jp	X0000		; 023d  c3 00 00	C..
;
start5:	ld	hl,dma		; 0240  21 80 00	!..
	ld	a,(hl)		; 0243  7e		~
	ld	(hl),l		; 0244  75		u
	inc	(hl)		; 0245  34		4
	or	a		; 0246  b7		7
	jr	z,start10	; 0247  28 30		(0	; parameter error
	xor	a		; 0249  af		/
	ld	(X121d),a	; 024a  32 1d 12	2..
start6:	ld	hl,dma		; 024d  21 80 00	!..
	ld	l,(hl)		; 0250  6e		n
start7:	ld	a,(hl)		; 0251  7e		~
	inc	hl		; 0252  23		#
	cp	20h		; 0253  fe 20		~ 
	jr	z,start7	; 0255  28 fa		(z
	or	a		; 0257  b7		7
	jr	z,start11	; 0258  28 28		((
	cp	48h		; 025a  fe 48		~H
	jr	nz,start8	; 025c  20 07		 .
	call	X029a		; 025e  cd 9a 02	M..
	jr	c,start10	; 0261  38 16		8.
	jr	start6		; 0263  18 e8		.h
;
start8:	cp	46h		; 0265  fe 46		~F
	jr	nz,start9	; 0267  20 07		 .
	call	X037f		; 0269  cd 7f 03	M..
	jr	c,start10	; 026c  38 0b		8.
	jr	start6		; 026e  18 dd		.]
;
start9:	cp	49h		; 0270  fe 49		~I
	jr	nz,start12	; 0272  20 1d		 .
	call	X03d4		; 0274  cd d4 03	MT.
	jr	nc,start6	; 0277  30 d4		0T
start10:
	ld	hl,permsg	; 0279  21 4e 0e	!N.	; missing parameter
	call	print		; 027c  cd 9a 0d	M..
	jp	X0000		; 027f  c3 00 00	C..
;
start11:
	ld	a,(X121d)	; 0282  3a 1d 12	:..
	or	a		; 0285  b7		7
	jr	z,start10	; 0286  28 f1		(q
	ld	a,(X121e)	; 0288  3a 1e 12	:..
	or	a		; 028b  b7		7
	jr	z,start10	; 028c  28 eb		(k
	jp	main		; 028e  c3 22 04	C".
;
start12:
	cp	43h		; 0291  fe 43		~C
	jr	nz,start10	; 0293  20 e4		 d
	call	X03ef		; 0295  cd ef 03	Mo.
	jr	start10		; 0298  18 df		._
;
X029a:	ld	bc,X0000	; 029a  01 00 00	...
	ld	(X1223),bc	; 029d  ed 43 23 12	mC#.
	ld	a,(hl)		; 02a1  7e		~
	inc	hl		; 02a2  23		#
	cp	3dh		; 02a3  fe 3d		~=
	jr	z,X02b8		; 02a5  28 11		(.
	sub	30h		; 02a7  d6 30		V0
	ret	c		; 02a9  d8		X
	cp	4		; 02aa  fe 04		~.
	ccf			; 02ac  3f		?
	ret	c		; 02ad  d8		X
	rlca			; 02ae  07		.
	rlca			; 02af  07		.
	rlca			; 02b0  07		.
	ld	c,a		; 02b1  4f		O
	ld	a,(hl)		; 02b2  7e		~
	inc	hl		; 02b3  23		#
	cp	3dh		; 02b4  fe 3d		~=
	scf			; 02b6  37		7
	ret	nz		; 02b7  c0		@
X02b8:	ld	a,l		; 02b8  7d		}
	ld	(dma),a		; 02b9  32 80 00	2..
X02bc:	ld	a,(hl)		; 02bc  7e		~
	inc	hl		; 02bd  23		#
	cp	20h		; 02be  fe 20		~ 
	jr	z,X02d2		; 02c0  28 10		(.
	jr	c,X02d2		; 02c2  38 0e		8.
	inc	b		; 02c4  04		.
	cp	2ah		; 02c5  fe 2a		~*
	jr	z,X02bc		; 02c7  28 f3		(s
	cp	41h		; 02c9  fe 41		~A
	ret	c		; 02cb  d8		X
	cp	51h		; 02cc  fe 51		~Q
	ccf			; 02ce  3f		?
	ret	c		; 02cf  d8		X
	jr	X02bc		; 02d0  18 ea		.j
;
X02d2:	ld	a,b		; 02d2  78		x
	cp	5		; 02d3  fe 05		~.
	ccf			; 02d5  3f		?
	ret	c		; 02d6  d8		X
	ld	hl,X0142	; 02d7  21 42 01	!B.
	ld	de,X0010	; 02da  11 10 00	...
X02dd:	add	hl,de		; 02dd  19		.
	dec	a		; 02de  3d		=
	jr	nz,X02dd	; 02df  20 fc		 |
	ld	(X1221),hl	; 02e1  22 21 12	"!.
X02e4:	ld	hl,dma		; 02e4  21 80 00	!..
	ld	a,(hl)		; 02e7  7e		~
	inc	(hl)		; 02e8  34		4
	ld	l,a		; 02e9  6f		o
	ld	a,(hl)		; 02ea  7e		~
	cp	2ah		; 02eb  fe 2a		~*
	jr	z,X02fa		; 02ed  28 0b		(.
	ld	a,(X121d)	; 02ef  3a 1d 12	:..
	cp	4		; 02f2  fe 04		~.
	jr	nc,X0311	; 02f4  30 1b		0.	; illegal drive assignment
	ld	a,(hl)		; 02f6  7e		~
	call	X0317		; 02f7  cd 17 03	M..
X02fa:	ld	hl,(X1221)	; 02fa  2a 21 12	*!.	; get table entry pointer
	ld	e,(hl)		; 02fd  5e		^
	inc	hl		; 02fe  23		#
	ld	d,(hl)		; 02ff  56		V
	inc	hl		; 0300  23		#
	inc	hl		; 0301  23		#
	inc	hl		; 0302  23		#
	ld	(X1221),hl	; 0303  22 21 12	"!.
	ld	hl,(X1223)	; 0306  2a 23 12	*#.
	add	hl,de		; 0309  19		.
	ld	(X1223),hl	; 030a  22 23 12	"#.
	djnz	X02e4		; 030d  10 d5		.U
	xor	a		; 030f  af		/
	ret			; 0310  c9		I
;
X0311:	ld	hl,idamsg	; 0311  21 2e 0e	!..
	jp	done		; 0314  c3 cf 0b	CO.
;
X0317:	sub	41h		; 0317  d6 41		VA
	add	a,a		; 0319  87		.
	ld	e,a		; 031a  5f		_
	ld	d,h		; 031b  54		T
	ld	hl,fcb0		; 031c  21 05 0d	!..
	add	hl,de		; 031f  19		.
	ld	a,(hl)		; 0320  7e		~
	inc	hl		; 0321  23		#
	or	(hl)		; 0322  b6		6
	dec	hl		; 0323  2b		+
	jr	nz,X0311	; 0324  20 eb		 k
	ld	de,(X1225)	; 0326  ed 5b 25 12	m[%.
	ld	(hl),e		; 032a  73		s
	inc	hl		; 032b  23		#
	ld	(hl),d		; 032c  72		r
	ld	hl,(biosend)	; 032d  2a 1f 12	*..
	push	bc		; 0330  c5		E
	ld	bc,X00c0	; 0331  01 c0 00	.@.
	add	hl,bc		; 0334  09		.
	ex	de,hl		; 0335  eb		k
	sbc	hl,de		; 0336  ed 52		mR
	ex	de,hl		; 0338  eb		k
	ld	iy,X0588	; 0339  fd 21 88 05	}!..
	add	iy,de		; 033d  fd 19		}.
	push	iy		; 033f  fd e5		}e
	pop	de		; 0341  d1		Q
	ld	hl,(X1221)	; 0342  2a 21 12	*!.
	ld	a,(hl)		; 0345  7e		~
	inc	hl		; 0346  23		#
	ld	(iy+1dh),a	; 0347  fd 77 1d	}w.
	ld	a,(hl)		; 034a  7e		~
	inc	hl		; 034b  23		#
	ld	(iy+1eh),a	; 034c  fd 77 1e	}w.
	ld	a,(hl)		; 034f  7e		~
	inc	hl		; 0350  23		#
	ld	h,(hl)		; 0351  66		f
	ld	l,a		; 0352  6f		o
	inc	de		; 0353  13		.
	inc	de		; 0354  13		.
	ld	bc,X0007	; 0355  01 07 00	...
	ldir			; 0358  ed b0		m0
	pop	bc		; 035a  c1		A
	ld	hl,(X1223)	; 035b  2a 23 12	*#.
	ld	(iy+1bh),l	; 035e  fd 75 1b	}u.
	ld	(iy+1ch),h	; 0361  fd 74 1c	}t.
	ld	(iy+18h),c	; 0364  fd 71 18	}q.
	ld	hl,(X0150)	; 0367  2a 50 01	*P.
	ld	(iy+19h),l	; 036a  fd 75 19	}u.
	ld	(iy+1ah),h	; 036d  fd 74 1a	}t.
	ld	hl,(X1225)	; 0370  2a 25 12	*%.
	ld	de,X00b0	; 0373  11 b0 00	.0.
	add	hl,de		; 0376  19		.
	ld	(X1225),hl	; 0377  22 25 12	"%.
	ld	hl,X121d	; 037a  21 1d 12	!..
	inc	(hl)		; 037d  34		4
	ret			; 037e  c9		I
;
X037f:	ld	a,(hl)		; 037f  7e		~
X0380:	inc	hl		; 0380  23		#
	cp	3dh		; 0381  fe 3d		~=
	scf			; 0383  37		7
	ret	nz		; 0384  c0		@
	ld	a,(X121e)	; 0385  3a 1e 12	:..
	or	a		; 0388  b7		7
	scf			; 0389  37		7
	ret	nz		; 038a  c0		@
	ld	a,(hl)		; 038b  7e		~
	ld	(X121e),a	; 038c  32 1e 12	2..
	ld	bc,X04ff	; 038f  01 ff 04	...
	ld	de,(X1256)	; 0392  ed 5b 56 12	m[V.
	ld	(X1227),de	; 0396  ed 53 27 12	mS'.
X039a:	ld	a,(hl)		; 039a  7e		~
	inc	hl		; 039b  23		#
	cp	20h		; 039c  fe 20		~ 
	jr	z,X03cd		; 039e  28 2d		(-
	jr	c,X03cd		; 03a0  38 2b		8+
	sub	41h		; 03a2  d6 41		VA
	ret	c		; 03a4  d8		X
	cp	10h		; 03a5  fe 10		~.
	ccf			; 03a7  3f		?
	ret	c		; 03a8  d8		X
	add	a,a		; 03a9  87		.
	ld	e,a		; 03aa  5f		_
	ld	d,h		; 03ab  54		T
	ld	a,l		; 03ac  7d		}
	ld	(dma),a		; 03ad  32 80 00	2..
	ld	hl,fcb0		; 03b0  21 05 0d	!..
	add	hl,de		; 03b3  19		.
	ld	d,h		; 03b4  54		T
	ld	e,l		; 03b5  5d		]
	ld	a,(hl)		; 03b6  7e		~
	inc	hl		; 03b7  23		#
	or	(hl)		; 03b8  b6		6
	jp	nz,X0311	; 03b9  c2 11 03	B..
	ld	hl,(X1227)	; 03bc  2a 27 12	*'.
	ldi			; 03bf  ed a0		m 
	ldi			; 03c1  ed a0		m 
	ld	(X1227),hl	; 03c3  22 27 12	"'.
	ld	hl,dma		; 03c6  21 80 00	!..
	ld	l,(hl)		; 03c9  6e		n
	djnz	X039a		; 03ca  10 ce		.N
	ld	a,(hl)		; 03cc  7e		~
X03cd:	cp	20h		; 03cd  fe 20		~ 
	ret	z		; 03cf  c8		H
	or	a		; 03d0  b7		7
	ret	z		; 03d1  c8		H
	scf			; 03d2  37		7
	ret			; 03d3  c9		I
;
X03d4:	ld	a,(hl)		; 03d4  7e		~
	inc	hl		; 03d5  23		#
	cp	4eh		; 03d6  fe 4e		~N
	scf			; 03d8  37		7
	ret	nz		; 03d9  c0		@
	ld	a,(hl)		; 03da  7e		~
	inc	hl		; 03db  23		#
	cp	49h		; 03dc  fe 49		~I
	scf			; 03de  37		7
	ret	nz		; 03df  c0		@
	ld	a,(hl)		; 03e0  7e		~
	inc	hl		; 03e1  23		#
	cp	54h		; 03e2  fe 54		~T
	scf			; 03e4  37		7
	ret	nz		; 03e5  c0		@
	ld	(X1229),a	; 03e6  32 29 12	2).
	ld	a,l		; 03e9  7d		}
	ld	(dma),a		; 03ea  32 80 00	2..
	xor	a		; 03ed  af		/
	ret			; 03ee  c9		I
;
X03ef:	ld	a,(hl)		; 03ef  7e		~
	inc	hl		; 03f0  23		#
	cp	3dh		; 03f1  fe 3d		~=
	ret	nz		; 03f3  c0		@
	push	hl		; 03f4  e5		e
	ld	hl,(X0006)	; 03f5  2a 06 00	*..
	ld	de,X07fe	; 03f8  11 fe 07	.~.
	sbc	hl,de		; 03fb  ed 52		mR
	ld	c,0		; 03fd  0e 00		..
X03ff:	ex	de,hl		; 03ff  eb		k
	pop	hl		; 0400  e1		a
X0401:	ld	a,(hl)		; 0401  7e		~
	inc	hl		; 0402  23		#
	or	a		; 0403  b7		7
	jr	z,X0415		; 0404  28 0f		(.
	cp	61h		; 0406  fe 61		~a
	jr	c,X0410		; 0408  38 06		8.
	cp	7bh		; 040a  fe 7b		~{
	jr	nc,X0410	; 040c  30 02		0.
	and	5fh		; 040e  e6 5f		f_
X0410:	ld	(de),a		; 0410  12		.
	inc	de		; 0411  13		.
	inc	c		; 0412  0c		.
	jr	X0401		; 0413  18 ec		.l
;
X0415:	ld	(de),a		; 0415  12		.
	ld	h,d		; 0416  62		b
	ld	l,7		; 0417  2e 07		..
	ld	(hl),c		; 0419  71		q
	ld	l,88h		; 041a  2e 88		..
	ld	e,8		; 041c  1e 08		..
	ld	(hl),e		; 041e  73		s
	inc	hl		; 041f  23		#
	ld	(hl),d		; 0420  72		r
	pop	hl		; 0421  e1		a
; 
main:	ld	hl,fcb0		; 0422  21 05 0d	!..
	ld	a,(hl)		; 0425  7e		~
	inc	hl		; 0426  23		#
	or	(hl)		; 0427  b6		6
	ld	hl,ndfmsg	; 0428  21 74 0e	!t.
	jp	z,done		; 042b  ca cf 0b	JO.
	ld	hl,(biosend)	; 042e  2a 1f 12	*..
	ld	de,hdbios	; 0431  11 b8 04	.8.
	sbc	hl,de		; 0434  ed 52		mR
	ld	b,h		; 0436  44		D
	ld	c,l		; 0437  4d		M
	ld	hl,adrtbl	; 0438  21 38 08	!8.
main1:	ld	e,(hl)		; 043b  5e		^
	inc	hl		; 043c  23		#
	ld	d,(hl)		; 043d  56		V
	inc	hl		; 043e  23		#
	ld	a,d		; 043f  7a		z
	or	e		; 0440  b3		3
	jr	z,main2		; 0441  28 0e		(.
	push	hl		; 0443  e5		e
	ex	de,hl		; 0444  eb		k
	ld	e,(hl)		; 0445  5e		^
	inc	hl		; 0446  23		#
	ld	d,(hl)		; 0447  56		V
	ex	de,hl		; 0448  eb		k
	add	hl,bc		; 0449  09		.
	ex	de,hl		; 044a  eb		k
	ld	(hl),d		; 044b  72		r
	dec	hl		; 044c  2b		+
	ld	(hl),e		; 044d  73		s
	pop	hl		; 044e  e1		a
	jr	main1		; 044f  18 ea		.j
;
main2:	ld	hl,hdbios	; 0451  21 b8 04	!8.
	ld	de,(biosend)	; 0454  ed 5b 1f 12	m[..	; transfer driver to end of BIOS
	ld	bc,X0380	; 0458  01 80 03	...
	ldir			; 045b  ed b0		m0
	ld	a,50h		; 045d  3e 50		>P
	out	(0ech),a	; 045f  d3 ec		Sl
	ld	a,10h		; 0461  3e 10		>.
	out	(htdtl),a	; 0463  d3 c1		SA
	ld	bc,X8000	; 0465  01 00 80	...
main3:	dec	bc		; 0468  0b		.
	ld	a,b		; 0469  78		x
	or	c		; 046a  b1		1
	jr	nz,main3	; 046b  20 fb		 {
	ld	a,0ch		; 046d  3e 0c		>.
	out	(htdtl),a	; 046f  d3 c1		SA
	ex	(sp),hl		; 0471  e3		c
	ex	(sp),hl		; 0472  e3		c
	in	a,(wdcsr)	; 0473  db cf		[O
	and	80h		; 0475  e6 80		f.
	jr	nz,main4	; 0477  20 15		 .
	out	(wdsdh),a	; 0479  d3 ce		SN
	ld	a,10h		; 047b  3e 10		>.
	out	(wdcsr),a	; 047d  d3 cf		SO
	call	wdrdy		; 047f  cd 42 05	MB.
	xor	a		; 0482  af		/
	out	(0cch),a	; 0483  d3 cc		SL
	out	(wdcylh),a	; 0485  d3 cd		SM
	ld	a,70h		; 0487  3e 70		>p
	call	wdrdy		; 0489  cd 42 05	MB.
	jr	z,main5		; 048c  28 06		(.
main4:	ld	hl,nrmsg	; 048e  21 99 0e	!..
	jp	done		; 0491  c3 cf 0b	CO.
;
main5:	ld	a,26h		; 0494  3e 26		>&
	out	(wderrg),a	; 0496  d3 c9		SI
	ld	a,(X1229)	; 0498  3a 29 12	:).
	or	a		; 049b  b7		7
	call	nz,init		; 049c  c4 6c 08	Dl.
	ld	a,(X0d06)	; 049f  3a 06 0d	:..
	ld	hl,X1220	; 04a2  21 20 12	! .
	cp	(hl)		; 04a5  be		>
	jp	nc,X0b6f	; 04a6  d2 6f 0b	Ro.
	ld	hl,fcb0		; 04a9  21 05 0d	!..
	ld	de,(X1256)	; 04ac  ed 5b 56 12	m[V.
	ld	bc,X0020	; 04b0  01 20 00	. .
	ldir			; 04b3  ed b0		m0
	jp	X0000		; 04b5  c3 00 00	C..
;
; BIOS Drivers
; 
hdbios:	di			; 04b8  f3		s
	dec	a		; 04b9  3d		=
	jr	z,hdread	; 04ba  28 06		(.
	dec	a		; 04bc  3d		=
	jr	z,hdwrite	; 04bd  28 11		(.
	or	80h		; 04bf  f6 80		v.
	ret			; 04c1  c9		I
;
hdread:	call	sethdc		; 04c2  cd 19 05	M..
	ld	a,20h		; 04c5  3e 20		> 
	out	(wdcsr),a	; 04c7  d3 cf		SO
	call	wdrdy		; 04c9  cd 42 05	MB.
	inir			; 04cc  ed b2		m2
	jr	hdcomp		; 04ce  18 22		."
;
hdwrite:
	ld	a,(ix+3)	; 04d0  dd 7e 03	]~.
	rra			; 04d3  1f		.
	rra			; 04d4  1f		.
	rra			; 04d5  1f		.
	and	3		; 04d6  e6 03		f.
	inc	a		; 04d8  3c		<
	push	bc		; 04d9  c5		E
	ld	b,a		; 04da  47		G
	in	a,(wpreg)	; 04db  db c0		[@
X04dd:	rlca			; 04dd  07		.
	djnz	X04dd		; 04de  10 fd		.}
;
;	and	1		; 04e0  e6 01		f.
; don't check write protect
	and	0
;
	ld	a,40h		; 04e2  3e 40		>@
	pop	bc		; 04e4  c1		A
	ret	nz		; 04e5  c0		@
	call	sethdc		; 04e6  cd 19 05	M..
	ld	a,30h		; 04e9  3e 30		>0
	out	(wdcsr),a	; 04eb  d3 cf		SO
	otir			; 04ed  ed b3		m3
	call	wdrdy		; 04ef  cd 42 05	MB.
hdcomp:	or	a		; 04f2  b7		7
	push	af		; 04f3  f5		u
	in	a,(wdcsr)	; 04f4  db cf		[O
	and	2		; 04f6  e6 02		f.
	jr	z,X0502		; 04f8  28 08		(.
	ld	a,10h		; 04fa  3e 10		>.
	out	(htdtl),a	; 04fc  d3 c1		SA
	ld	a,0ch		; 04fe  3e 0c		>.
	out	(htdtl),a	; 0500  d3 c1		SA
X0502:	pop	af		; 0502  f1		q
	ret	z		; 0503  c8		H
	in	a,(wderrg)	; 0504  db c9		[I
	ld	hl,X0510	; 0506  21 10 05	!..
	scf			; 0509  37		7
X050a:	inc	hl		; 050a  23		#
	rlca			; 050b  07		.
	jr	nc,X050a	; 050c  30 fc		0|
	ld	a,(hl)		; 050e  7e		~
	or	a		; 050f  b7		7
X0510:	ret			; 0510  c9		I
;
errcod:	db	10h,8,10h,10h,0,80h,80h,4		; 0511 ........
;
; Setup hard drive controller registers
;
sethdc:	push	hl		; 0519  e5		e
	ld	l,(ix+6)	; 051a  dd 6e 06	]n.
	ld	h,(ix+7)	; 051d  dd 66 07	]f.
	add	hl,bc		; 0520  09		.
	ld	c,(ix+4)	; 0521  dd 4e 04	]N.
	ld	b,(ix+5)	; 0524  dd 46 05	]F.
	xor	a		; 0527  af		/
X0528:	sbc	hl,bc		; 0528  ed 42		mB
	inc	a		; 052a  3c		<
	jr	nc,X0528	; 052b  30 fb		0{
	dec	a		; 052d  3d		=
	add	hl,bc		; 052e  09		.
	or	(ix+3)		; 052f  dd b6 03	]6.
	out	(wdsdh),a	; 0532  d3 ce		SN
	ld	a,e		; 0534  7b		{
	out	(wdset),a	; 0535  d3 cb		SK
	ld	a,l		; 0537  7d		}
	out	(0cch),a	; 0538  d3 cc		SL
	ld	a,h		; 053a  7c		|
	out	(wdcylh),a	; 053b  d3 cd		SM
	ld	bc,X00c8	; 053d  01 c8 00	.H.
	pop	hl		; 0540  e1		a
	ret			; 0541  c9		I
;
wdrdy:	ex	(sp),hl		; 0542  e3		c
	ex	(sp),hl		; 0543  e3		c
X0544:	in	a,(wdcsr)	; 0544  db cf		[O
	rlca			; 0546  07		.
	jr	c,X0544		; 0547  38 fb		8{
	in	a,(wdcsr)	; 0549  db cf		[O
	and	1		; 054b  e6 01		f.
	ret			; 054d  c9		I
;
sectbl:	db	1,2,3,4,5,6,7,8				; 054e ........
	db	9,0ah,0bh,0ch,0dh,0eh,0fh,10h		; 0556 ........
	db	11h,12h,13h,14h,15h,16h,17h,18h		; 055e ........
	db	19h,1ah,1bh,1ch,1dh,1eh,1fh,20h		; 0566 ....... 
	db	0,0,0,0,0,0,0,0				; 056e ........
	db	0,0					; 0576 ..
drvatbl:
	dw	54eh		; 0578   4e 05      N.
	dw	0		; 057a   00 00      ..
	dw	0		; 057c   00 00      ..
	dw	0		; 057e   00 00      ..
X0580:	dw	0		; 0580   00 00      ..
X0582:	dw	588h		; 0582   88 05      ..
	dw	0		; 0584   00 00      ..
X0586:	dw	5a8h		; 0586   a8 05      (.
;
X0588:	db	40h,0,5,1fh,3,0,0,0ffh			; 0588 @.......
	db	0,wpreg,0,0,0,2,0,20h			; 0590 .@..... 
	db	1					; 0598 .
X0599:	dw	59dh		; 0599   9d 05      ..
	dw	0		; 059b   00 00      ..
;
;
	jp	hdbios		; 059d  c3 b8 04	C8.
;
	org	628h
;
drvbtbl:
	dw	54eh		; 0628   4e 05      N.
	dw	0		; 062a   00 00      ..
	dw	0		; 062c   00 00      ..
	dw	0		; 062e   00 00      ..
X0630:	dw	0		; 0630   00 00      ..
X0632:	dw	638h		; 0632   38 06      8.
	dw	0		; 0634   00 00      ..
X0636:	dw	658h		; 0636   58 06      X.
;
	db	40h,0,5,1fh,3,0,0,0ffh			; 0638 @.......
	db	0,wpreg,0,0,0,2,0,20h			; 0640 .@..... 
	db	1					; 0648 .
X0649:	dw	64dh		; 0649   4d 06      M.
	dw	0		; 064b   00 00      ..
;
;
	jp	hdbios		; 064d  c3 b8 04	C8.
;
	org	6d8h
;
drvctbl:
	dw	54eh		; 06d8   4e 05      N.
	dw	0		; 06da   00 00      ..
	dw	0		; 06dc   00 00      ..
	dw	0		; 06de   00 00      ..
X06e0:	dw	0		; 06e0   00 00      ..
X06e2:	dw	6e8h		; 06e2   e8 06      h.
	dw	0		; 06e4   00 00      ..
X06e6:	dw	708h		; 06e6   08 07      ..
;
	db	40h,0,5,1fh,3,0,0,0ffh			; 06e8 @.......
	db	0,wpreg,0,0,0,2,0,20h			; 06f0 .@..... 
	db	1					; 06f8 .
X06f9:	dw	6fdh		; 06f9   fd 06      }.
	dw	0		; 06fb   00 00      ..
;
;
	jp	hdbios		; 06fd  c3 b8 04	C8.
;
	org	788h
;
drvdtbl:
	dw	54eh		; 0788   4e 05      N.
	dw	0		; 078a   00 00      ..
	dw	0		; 078c   00 00      ..
	dw	0		; 078e   00 00      ..
X0790:	dw	0		; 0790   00 00      ..
X0792:	dw	798h		; 0792   98 07      ..
	dw	0		; 0794   00 00      ..
X0796:	dw	7b8h		; 0796   b8 07      8.
;
	db	40h,0,5,1fh,3,0,0,0ffh			; 0798 @.......
	db	0,wpreg,0,0,0,2,0,20h			; 07a0 .@..... 
	db	1					; 07a8 .
X07a9:	dw	7adh		; 07a9   ad 07      -.
	dw	0		; 07ab   00 00      ..
;
;
	jp	hdbios		; 07ad  c3 b8 04	C8.
;
	org	7feh
;
X07fe:	nop			; 07fe  00		.	; data truncated
;
	org	806h
;
X0806:	nop			; 0806  00		.	; data truncated
; 
; End of BIOS drivers
;
	org	838h
;
adrtbl:	dw	X04c3		; 0838   c3 04      C.
	dw	X04ca		; 083a   ca 04      J.
	dw	X04e7		; 083c   e7 04      g.
	dw	X04f0		; 083e   f0 04      p.
	dw	X0507		; 0840   07 05      ..
	dw	drvatbl		; 0842   78 05      x.
	dw	X0582		; 0844   82 05      ..
	dw	X0586		; 0846   86 05      ..
	dw	X0599		; 0848   99 05      ..
	dw	X059e		; 084a   9e 05      ..
	dw	drvbtbl		; 084c   28 06      (.
	dw	X0632		; 084e   32 06      2.
	dw	X0636		; 0850   36 06      6.
	dw	X0649		; 0852   49 06      I.
	dw	X064e		; 0854   4e 06      N.
	dw	drvctbl		; 0856   d8 06      X.
	dw	X06e2		; 0858   e2 06      b.
	dw	X06e6		; 085a   e6 06      f.
	dw	X06f9		; 085c   f9 06      y.
	dw	X06fe		; 085e   fe 06      ~.
	dw	drvdtbl		; 0860   88 07      ..
	dw	X0792		; 0862   92 07      ..
	dw	X0796		; 0864   96 07      ..
	dw	X07a9		; 0866   a9 07      ).
	dw	X07ae		; 0868   ae 07      ..
	dw	X0000		; 086a   00 00      ..
;
init:	ld	hl,fmtmsg	; 086c  21 c2 0e	!B.
	call	print		; 086f  cd 9a 0d	M..
X0872:	ld	e,0ffh		; 0872  1e ff		..
	ld	c,6		; 0874  0e 06		..
	call	X0005		; 0876  cd 05 00	M..
	and	5fh		; 0879  e6 5f		f_
	jr	z,X0872		; 087b  28 f5		(u
	cp	59h		; 087d  fe 59		~Y
	jp	nz,X0000	; 087f  c2 00 00	B..
	ld	hl,ftrkms	; 0882  21 89 0f	!..
	call	print		; 0885  cd 9a 0d	M..
X0888:	ld	hl,nftmsg	; 0888  21 fb 0f	!{.
	call	print		; 088b  cd 9a 0d	M..
	ld	hl,dma		; 088e  21 80 00	!..
	ld	c,0ah		; 0891  0e 0a		..
	ld	(hl),c		; 0893  71		q
	ex	de,hl		; 0894  eb		k
	call	X0005		; 0895  cd 05 00	M..
	ld	hl,X0082	; 0898  21 82 00	!..
	ld	a,(X0081)	; 089b  3a 81 00	:..
	or	a		; 089e  b7		7
	jr	z,X08f3		; 089f  28 52		(R
	ld	e,a		; 08a1  5f		_
	ld	d,0		; 08a2  16 00		..
	ex	de,hl		; 08a4  eb		k
	add	hl,de		; 08a5  19		.
	ld	(hl),0		; 08a6  36 00		6.
	ex	de,hl		; 08a8  eb		k
	call	X0db0		; 08a9  cd b0 0d	M0.
	jr	nz,X08d6	; 08ac  20 28		 (
	ld	a,e		; 08ae  7b		{
	cp	4		; 08af  fe 04		~.
	jr	nc,X08d6	; 08b1  30 23		0#
	rlca			; 08b3  07		.
	rlca			; 08b4  07		.
	rlca			; 08b5  07		.
	ld	c,a		; 08b6  4f		O
	ld	a,(hl)		; 08b7  7e		~
	inc	hl		; 08b8  23		#
	cp	2ch		; 08b9  fe 2c		~,
	jr	nz,X08d6	; 08bb  20 19		 .
	call	X0db0		; 08bd  cd b0 0d	M0.
	jr	nz,X08d6	; 08c0  20 14		 .
	ld	a,e		; 08c2  7b		{
	cp	8		; 08c3  fe 08		~.
	jr	nc,X08d6	; 08c5  30 0f		0.
	or	c		; 08c7  b1		1
	ld	c,a		; 08c8  4f		O
	ld	a,(hl)		; 08c9  7e		~
	inc	hl		; 08ca  23		#
	cp	2ch		; 08cb  fe 2c		~,
	jr	nz,X08d6	; 08cd  20 07		 .
	call	X0db0		; 08cf  cd b0 0d	M0.
	ld	a,(hl)		; 08d2  7e		~
	or	a		; 08d3  b7		7
	jr	z,X08de		; 08d4  28 08		(.
X08d6:	ld	hl,peemsg	; 08d6  21 1b 10	!..
	call	print		; 08d9  cd 9a 0d	M..
	jr	X0888		; 08dc  18 aa		.*
;
X08de:	ld	hl,(X122a)	; 08de  2a 2a 12	**.
	ld	(hl),c		; 08e1  71		q
	inc	hl		; 08e2  23		#
	ld	(hl),e		; 08e3  73		s
	inc	hl		; 08e4  23		#
	ld	(hl),d		; 08e5  72		r
	inc	hl		; 08e6  23		#
	ld	(X122a),hl	; 08e7  22 2a 12	"*.
	ld	a,(X122c)	; 08ea  3a 2c 12	:,.
	inc	a		; 08ed  3c		<
	ld	(X122c),a	; 08ee  32 2c 12	2,.
	jr	X0888		; 08f1  18 95		..
;
X08f3:	ld	hl,fcb0		; 08f3  21 05 0d	!..
	ld	(X1225),hl	; 08f6  22 25 12	"%.
	ld	a,41h		; 08f9  3e 41		>A
	ld	(dnum),a	; 08fb  32 5b 10	2[.
X08fe:	ld	hl,(X1225)	; 08fe  2a 25 12	*%.
	ld	e,(hl)		; 0901  5e		^
	inc	hl		; 0902  23		#
	ld	d,(hl)		; 0903  56		V
	inc	hl		; 0904  23		#
	ld	(X1225),hl	; 0905  22 25 12	"%.
	ld	a,(X1220)	; 0908  3a 20 12	: .
	dec	a		; 090b  3d		=
	cp	d		; 090c  ba		:
	call	c,format	; 090d  dc 1c 09	\..
	ld	a,(dnum)	; 0910  3a 5b 10	:[.
	inc	a		; 0913  3c		<
	ld	(dnum),a	; 0914  32 5b 10	2[.
	cp	51h		; 0917  fe 51		~Q
	jr	c,X08fe		; 0919  38 e3		8c
	ret			; 091b  c9		I
;
format:	ld	hl,X000a	; 091c  21 0a 00	!..
	add	hl,de		; 091f  19		.
	ld	e,(hl)		; 0920  5e		^
	inc	hl		; 0921  23		#
	ld	d,(hl)		; 0922  56		V
	push	de		; 0923  d5		U
	pop	iy		; 0924  fd e1		}a
	ld	l,(iy+11h)	; 0926  fd 6e 11	}n.
	ld	h,(iy+12h)	; 0929  fd 66 12	}f.
	push	hl		; 092c  e5		e
	pop	ix		; 092d  dd e1		]a
	ld	hl,X13ea	; 092f  21 ea 13	!j.
	ld	(X122d),hl	; 0932  22 2d 12	"-.
	xor	a		; 0935  af		/
	ld	(X122f),a	; 0936  32 2f 12	2/.
	ld	(X123e),a	; 0939  32 3e 12	2>.
	ld	hl,buffer	; 093c  21 ea 12	!j.
	ld	de,X12eb	; 093f  11 eb 12	.k.
	ld	bc,X00ff	; 0942  01 ff 00	...
	ld	(hl),0e5h	; 0945  36 e5		6e
	ldir			; 0947  ed b0		m0
	ld	hl,fmtdms	; 0949  21 46 10	!F.
	call	print		; 094c  cd 9a 0d	M..
	ld	bc,X0000	; 094f  01 00 00	...
	ld	e,(ix+8)	; 0952  dd 5e 08	]^.
	ld	d,(ix+9)	; 0955  dd 56 09	]V.
	ld	hl,tnum1	; 0958  21 6e 10	!n.
	ld	(hl),30h	; 095b  36 30		60
	inc	hl		; 095d  23		#
	ld	(hl),30h	; 095e  36 30		60
	inc	hl		; 0960  23		#
	ld	(hl),30h	; 0961  36 30		60
	inc	hl		; 0963  23		#
	ld	(hl),30h	; 0964  36 30		60
X0966:	push	bc		; 0966  c5		E
	push	de		; 0967  d5		U
	ld	hl,tnum		; 0968  21 69 10	!i.
	call	print		; 096b  cd 9a 0d	M..
	call	fmttrk		; 096e  cd c1 09	MA.
	pop	de		; 0971  d1		Q
	pop	bc		; 0972  c1		A
	inc	bc		; 0973  03		.
	dec	de		; 0974  1b		.
	ld	hl,tnum2	; 0975  21 71 10	!q.
	call	X0b4f		; 0978  cd 4f 0b	MO.
	ld	a,d		; 097b  7a		z
	or	e		; 097c  b3		3
	jr	nz,X0966	; 097d  20 e7		 g
	ld	bc,X0000	; 097f  01 00 00	...
	ld	e,(ix+8)	; 0982  dd 5e 08	]^.
	ld	d,(ix+9)	; 0985  dd 56 09	]V.
	ld	hl,tnum1	; 0988  21 6e 10	!n.
	ld	(hl),30h	; 098b  36 30		60
	inc	hl		; 098d  23		#
	ld	(hl),30h	; 098e  36 30		60
	inc	hl		; 0990  23		#
	ld	(hl),30h	; 0991  36 30		60
	inc	hl		; 0993  23		#
	ld	(hl),30h	; 0994  36 30		60
	ld	hl,vrfmsg	; 0996  21 74 10	!t.
	call	print		; 0999  cd 9a 0d	M..
X099c:	push	bc		; 099c  c5		E
	push	de		; 099d  d5		U
	ld	hl,tnum		; 099e  21 69 10	!i.
	call	print		; 09a1  cd 9a 0d	M..
	call	X0a2a		; 09a4  cd 2a 0a	M*.
	pop	de		; 09a7  d1		Q
	pop	bc		; 09a8  c1		A
	inc	bc		; 09a9  03		.
	dec	de		; 09aa  1b		.
	ld	hl,tnum2	; 09ab  21 71 10	!q.
	call	X0b4f		; 09ae  cd 4f 0b	MO.
	ld	a,d		; 09b1  7a		z
	or	e		; 09b2  b3		3
	jr	nz,X099c	; 09b3  20 e7		 g
	ld	a,(X122f)	; 09b5  3a 2f 12	:/.
	or	a		; 09b8  b7		7
	ret	z		; 09b9  c8		H
	ld	hl,bstmsg	; 09ba  21 05 11	!..
	call	print		; 09bd  cd 9a 0d	M..
	ret			; 09c0  c9		I
;
fmttrk:	call	wptest		; 09c1  cd 59 0b	MY.
	ld	hl,wptmsg	; 09c4  21 96 10	!..
	jr	nz,X09e4	; 09c7  20 1b		 .
	call	sethdc		; 09c9  cd 19 05	M..
	ld	a,0fh		; 09cc  3e 0f		>.
	out	(wdset),a	; 09ce  d3 cb		SK
	ld	a,20h		; 09d0  3e 20		> 
	out	(wdscnt),a	; 09d2  d3 ca		SJ
	ld	a,50h		; 09d4  3e 50		>P
	out	(wdcsr),a	; 09d6  d3 cf		SO
	ld	hl,siltbl	; 09d8  21 ea 09	!j.
	otir			; 09db  ed b3		m3
	call	wdrdy		; 09dd  cd 42 05	MB.
	ret	z		; 09e0  c8		H
X09e1:	ld	hl,fermsg	; 09e1  21 d5 10	!U.
X09e4:	call	print		; 09e4  cd 9a 0d	M..
	jp	X0000		; 09e7  c3 00 00	C..
;
; Sector Interleave Table
; 
siltbl:	db	0,1,0,5,0,9,0,0dh			; 09ea ........
	db	0,11h,0,15h,0,19h,0,1dh			; 09f2 ........
	db	0,2,0,6,0,0ah,0,0eh			; 09fa ........
	db	0,12h,0,16h,0,1ah,0,1eh			; 0a02 ........
	db	0,3,0,7,0,0bh,0,0fh			; 0a0a ........
	db	0,13h,0,17h,0,1bh,0,1fh			; 0a12 ........
	db	0,4,0,8,0,0ch,0,10h			; 0a1a ........
	db	0,14h,0,18h,0,1ch,0,20h			; 0a22 ....... 
;
X0a2a:	call	wptest		; 0a2a  cd 59 0b	MY.
	ld	hl,wptmsg	; 0a2d  21 96 10	!..
	jr	nz,X09e4	; 0a30  20 b2		 2
	push	bc		; 0a32  c5		E
	call	sethdc		; 0a33  cd 19 05	M..
	call	X0b1e		; 0a36  cd 1e 0b	M..
	pop	bc		; 0a39  c1		A
	jr	z,X0a76		; 0a3a  28 3a		(:
	ld	de,X0001	; 0a3c  11 01 00	...
X0a3f:	push	bc		; 0a3f  c5		E
	push	de		; 0a40  d5		U
	ld	hl,buffer	; 0a41  21 ea 12	!j.
	ld	a,2		; 0a44  3e 02		>.
	call	X0b6d		; 0a46  cd 6d 0b	Mm.
	pop	de		; 0a49  d1		Q
	pop	bc		; 0a4a  c1		A
	jr	nz,X0a6f	; 0a4b  20 22		 "
	inc	e		; 0a4d  1c		.
	ld	a,e		; 0a4e  7b		{
	cp	21h		; 0a4f  fe 21		~!
	jr	nz,X0a3f	; 0a51  20 ec		 l
	ld	e,1		; 0a53  1e 01		..
X0a55:	ld	a,e		; 0a55  7b		{
	out	(wdset),a	; 0a56  d3 cb		SK
	ld	a,20h		; 0a58  3e 20		> 
	out	(wdcsr),a	; 0a5a  d3 cf		SO
	call	wdrdy		; 0a5c  cd 42 05	MB.
	push	af		; 0a5f  f5		u
X0a60:	in	a,(wddata)	; 0a60  db c8		[H
	dec	d		; 0a62  15		.
	jr	nz,X0a60	; 0a63  20 fb		 {
	pop	af		; 0a65  f1		q
	jr	nz,X0a6f	; 0a66  20 07		 .
	inc	e		; 0a68  1c		.
	ld	a,e		; 0a69  7b		{
	cp	21h		; 0a6a  fe 21		~!
	ret	z		; 0a6c  c8		H
	jr	X0a55		; 0a6d  18 e6		.f
;
X0a6f:	in	a,(wderrg)	; 0a6f  db c9		[I
	and	70h		; 0a71  e6 70		fp
	jp	z,X09e1		; 0a73  ca e1 09	Ja.
X0a76:	push	bc		; 0a76  c5		E
	ld	c,(iy+0dh)	; 0a77  fd 4e 0d	}N.
	ld	b,(iy+0eh)	; 0a7a  fd 46 0e	}F.
	ld	de,X0001	; 0a7d  11 01 00	...
	ld	hl,X13ea	; 0a80  21 ea 13	!j.
	ld	a,1		; 0a83  3e 01		>.
	call	X0b6d		; 0a85  cd 6d 0b	Mm.
	jp	nz,X09e1	; 0a88  c2 e1 09	Ba.
	ld	hl,(X122d)	; 0a8b  2a 2d 12	*-.
	ld	a,(hl)		; 0a8e  7e		~
	cp	0e5h		; 0a8f  fe e5		~e
	jr	nz,X0aad	; 0a91  20 1a		 .
	push	hl		; 0a93  e5		e
	ex	de,hl		; 0a94  eb		k
	ld	hl,badtkm	; 0a95  21 32 12	!2.
	ld	a,(X123e)	; 0a98  3a 3e 12	:>.
	inc	a		; 0a9b  3c		<
	ld	(X123e),a	; 0a9c  32 3e 12	2>.
	cp	4		; 0a9f  fe 04		~.
	jp	z,X09e1		; 0aa1  ca e1 09	Ja.
	ld	bc,X0020	; 0aa4  01 20 00	. .
	ldir			; 0aa7  ed b0		m0
	pop	hl		; 0aa9  e1		a
	ld	c,10h		; 0aaa  0e 10		..
	add	hl,bc		; 0aac  09		.
X0aad:	ld	e,(iy+0dh)	; 0aad  fd 5e 0d	}^.
	ld	d,(iy+0eh)	; 0ab0  fd 56 0e	}V.
	ex	(sp),hl		; 0ab3  e3		c
	xor	a		; 0ab4  af		/
	sbc	hl,de		; 0ab5  ed 52		mR
	ex	de,hl		; 0ab7  eb		k
	pop	hl		; 0ab8  e1		a
	ret	c		; 0ab9  d8		X
	or	d		; 0aba  b2		2
	jr	nz,X0ac8	; 0abb  20 0b		 .
	ld	a,e		; 0abd  7b		{
	cp	2		; 0abe  fe 02		~.
	jr	nc,X0ac8	; 0ac0  30 06		0.
	ld	a,0ffh		; 0ac2  3e ff		>.
	ld	(X122f),a	; 0ac4  32 2f 12	2/.
	ret			; 0ac7  c9		I
;
X0ac8:	ex	de,hl		; 0ac8  eb		k
	ld	a,6		; 0ac9  3e 06		>.
	sub	(iy+2)		; 0acb  fd 96 02	}..
	ld	b,a		; 0ace  47		G
	ld	c,1		; 0acf  0e 01		..
	jr	z,X0aed		; 0ad1  28 1a		(.
	jr	nc,X0ae8	; 0ad3  30 13		0.
	srl	h		; 0ad5  cb 3c		K<
	rr	l		; 0ad7  cb 1d		K.
	jr	nc,X0aed	; 0ad9  30 12		0.
	ld	a,(X1230)	; 0adb  3a 30 12	:0.
	cp	l		; 0ade  bd		=
	jr	nz,X0aed	; 0adf  20 0c		 .
	ld	a,(X1231)	; 0ae1  3a 31 12	:1.
	cp	h		; 0ae4  bc		<
	ret	z		; 0ae5  c8		H
	jr	X0aed		; 0ae6  18 05		..
;
X0ae8:	add	hl,hl		; 0ae8  29		)
	sla	c		; 0ae9  cb 21		K!
	djnz	X0ae8		; 0aeb  10 fb		.{
X0aed:	ld	(X1230),hl	; 0aed  22 30 12	"0.
	ex	de,hl		; 0af0  eb		k
X0af1:	ld	(hl),e		; 0af1  73		s
	inc	hl		; 0af2  23		#
	push	bc		; 0af3  c5		E
	ld	c,(iy+5)	; 0af4  fd 4e 05	}N.
	ld	b,(iy+6)	; 0af7  fd 46 06	}F.
	inc	bc		; 0afa  03		.
	ld	a,b		; 0afb  78		x
	or	a		; 0afc  b7		7
	pop	bc		; 0afd  c1		A
	jr	z,X0b02		; 0afe  28 02		(.
	ld	(hl),d		; 0b00  72		r
	inc	hl		; 0b01  23		#
X0b02:	inc	de		; 0b02  13		.
	dec	c		; 0b03  0d		.
	jr	nz,X0af1	; 0b04  20 eb		 k
	ld	(X122d),hl	; 0b06  22 2d 12	"-.
	ld	c,(iy+0dh)	; 0b09  fd 4e 0d	}N.
	ld	b,(iy+0eh)	; 0b0c  fd 46 0e	}F.
	ld	de,X0001	; 0b0f  11 01 00	...
	ld	hl,X13ea	; 0b12  21 ea 13	!j.
	ld	a,2		; 0b15  3e 02		>.
	call	X0b6d		; 0b17  cd 6d 0b	Mm.
	jp	nz,X09e1	; 0b1a  c2 e1 09	Ba.
	ret			; 0b1d  c9		I
;
X0b1e:	push	bc		; 0b1e  c5		E
	in	a,(wdsdh)	; 0b1f  db ce		[N
	ld	c,a		; 0b21  4f		O
	in	a,(wdcylh)	; 0b22  db cd		[M
	ld	d,a		; 0b24  57		W
	in	a,(0cch)	; 0b25  db cc		[L
	ld	e,a		; 0b27  5f		_
	dec	a		; 0b28  3d		=
	or	d		; 0b29  b2		2
	jr	z,X0b4d		; 0b2a  28 21		(!
	ld	a,(X122c)	; 0b2c  3a 2c 12	:,.
	or	a		; 0b2f  b7		7
	jr	z,X0b4b		; 0b30  28 19		(.
	ld	b,a		; 0b32  47		G
	ld	hl,X14ea	; 0b33  21 ea 14	!j.
X0b36:	ld	a,c		; 0b36  79		y
	cp	(hl)		; 0b37  be		>
	inc	hl		; 0b38  23		#
	jr	nz,X0b47	; 0b39  20 0c		 .
	ld	a,e		; 0b3b  7b		{
	cp	(hl)		; 0b3c  be		>
	inc	hl		; 0b3d  23		#
	jr	nz,X0b48	; 0b3e  20 08		 .
	ld	a,d		; 0b40  7a		z
	cp	(hl)		; 0b41  be		>
	inc	hl		; 0b42  23		#
	jr	z,X0b4d		; 0b43  28 08		(.
	jr	X0b49		; 0b45  18 02		..
;
X0b47:	inc	hl		; 0b47  23		#
X0b48:	inc	hl		; 0b48  23		#
X0b49:	djnz	X0b36		; 0b49  10 eb		.k
X0b4b:	or	0ffh		; 0b4b  f6 ff		v.
X0b4d:	pop	bc		; 0b4d  c1		A
	ret			; 0b4e  c9		I
;
X0b4f:	ld	a,3ah		; 0b4f  3e 3a		>:
X0b51:	inc	(hl)		; 0b51  34		4
	cp	(hl)		; 0b52  be		>
	ret	nz		; 0b53  c0		@
	ld	(hl),30h	; 0b54  36 30		60
	dec	hl		; 0b56  2b		+
	jr	X0b51		; 0b57  18 f8		.x
;
wptest:	ld	a,(ix+3)	; 0b59  dd 7e 03	]~.
	rra			; 0b5c  1f		.
	rra			; 0b5d  1f		.
	rra			; 0b5e  1f		.
	and	3		; 0b5f  e6 03		f.
	inc	a		; 0b61  3c		<
	push	bc		; 0b62  c5		E
	ld	b,a		; 0b63  47		G
	in	a,(wpreg)	; 0b64  db c0		[@
X0b66:	rlca			; 0b66  07		.
	djnz	X0b66		; 0b67  10 fd		.}
;
;	and	1		; 0b69  e6 01		f.
; don't check write protect
	and	0
;
	pop	bc		; 0b6b  c1		A
	ret			; 0b6c  c9		I
;
X0b6d:	jp	(ix)		; 0b6d  dd e9		]i
;
X0b6f:	ld	hl,(X0006)	; 0b6f  2a 06 00	*..
	ld	de,X0806	; 0b72  11 06 08	...
	xor	a		; 0b75  af		/
	sbc	hl,de		; 0b76  ed 52		mR
	ld	(X0d03),hl	; 0b78  22 03 0d	"..
	ex	de,hl		; 0b7b  eb		k
	dec	d		; 0b7c  15		.
	ld	hl,(X1256)	; 0b7d  2a 56 12	*V.
	ld	(X0cf8),hl	; 0b80  22 f8 0c	"x.
	ld	hl,X0c88	; 0b83  21 88 0c	!..
	ld	bc,X0100	; 0b86  01 00 01	...
	ldir			; 0b89  ed b0		m0
	dec	d		; 0b8b  15		.
	push	de		; 0b8c  d5		U
	ld	hl,(fcb0)	; 0b8d  2a 05 0d	*..
	ld	c,0ah		; 0b90  0e 0a		..
	add	hl,bc		; 0b92  09		.
	ld	a,(hl)		; 0b93  7e		~
	inc	hl		; 0b94  23		#
	ld	h,(hl)		; 0b95  66		f
	ld	l,a		; 0b96  6f		o
	push	hl		; 0b97  e5		e
	pop	iy		; 0b98  fd e1		}a
	ld	l,(iy+11h)	; 0b9a  fd 6e 11	}n.
	ld	h,(iy+12h)	; 0b9d  fd 66 12	}f.
	push	hl		; 0ba0  e5		e
	pop	ix		; 0ba1  dd e1		]a
	ld	bc,X0001	; 0ba3  01 01 00	...
	call	fmttrk		; 0ba6  cd c1 09	MA.
	ld	bc,X0000	; 0ba9  01 00 00	...
	ld	de,X3101	; 0bac  11 01 31	..1
	pop	hl		; 0baf  e1		a
X0bb0:	push	bc		; 0bb0  c5		E
	push	de		; 0bb1  d5		U
	push	hl		; 0bb2  e5		e
	ld	a,2		; 0bb3  3e 02		>.
	call	X0b6d		; 0bb5  cd 6d 0b	Mm.
	pop	hl		; 0bb8  e1		a
	pop	de		; 0bb9  d1		Q
	pop	bc		; 0bba  c1		A
	jr	nz,X0bcc	; 0bbb  20 0f		 .
	inc	h		; 0bbd  24		$
	inc	e		; 0bbe  1c		.
	ld	a,e		; 0bbf  7b		{
	cp	21h		; 0bc0  fe 21		~!
	jr	nz,X0bc7	; 0bc2  20 03		 .
	ld	e,1		; 0bc4  1e 01		..
	inc	c		; 0bc6  0c		.
X0bc7:	dec	d		; 0bc7  15		.
	jr	z,X0bdb		; 0bc8  28 11		(.
	jr	X0bb0		; 0bca  18 e4		.d
;
X0bcc:	ld	hl,X11b2	; 0bcc  21 b2 11	!2.
done:	call	print		; 0bcf  cd 9a 0d	M..
	ld	hl,donems	; 0bd2  21 f3 11	!s.
	call	print		; 0bd5  cd 9a 0d	M..
	jp	X0000		; 0bd8  c3 00 00	C..
;
X0bdb:	ld	hl,fcb0		; 0bdb  21 05 0d	!..
	ld	de,(X1256)	; 0bde  ed 5b 56 12	m[V.
	ld	bc,X0020	; 0be2  01 20 00	. .
	ldir			; 0be5  ed b0		m0
	ld	c,0dh		; 0be7  0e 0d		..
	call	X0005		; 0be9  cd 05 00	M..
	ld	a,(X121e)	; 0bec  3a 1e 12	:..
	sub	40h		; 0bef  d6 40		V@
	ld	(fcb1),a	; 0bf1  32 3c 0c	2<.
	ld	de,fcb2		; 0bf4  11 62 0c	.b.
	ld	c,13h		; 0bf7  0e 13		..
	call	X0005		; 0bf9  cd 05 00	M..
	ld	de,fcb1		; 0bfc  11 3c 0c	.<.
	ld	c,0fh		; 0bff  0e 0f		..
	call	X0005		; 0c01  cd 05 00	M..
	inc	a		; 0c04  3c		<
	jp	z,X0000		; 0c05  ca 00 00	J..
	ld	de,fcb2		; 0c08  11 62 0c	.b.
	ld	c,16h		; 0c0b  0e 16		..
	call	X0005		; 0c0d  cd 05 00	M..
	inc	a		; 0c10  3c		<
	jp	z,X0000		; 0c11  ca 00 00	J..
X0c14:	ld	de,fcb1		; 0c14  11 3c 0c	.<.
	ld	c,14h		; 0c17  0e 14		..
	call	X0005		; 0c19  cd 05 00	M..
	or	a		; 0c1c  b7		7
	jr	nz,X0c29	; 0c1d  20 0a		 .
	ld	de,fcb2		; 0c1f  11 62 0c	.b.
	ld	c,15h		; 0c22  0e 15		..
	call	X0005		; 0c24  cd 05 00	M..
	jr	X0c14		; 0c27  18 eb		.k
;
X0c29:	ld	de,fcb2		; 0c29  11 62 0c	.b.
	ld	c,10h		; 0c2c  0e 10		..
	call	X0005		; 0c2e  cd 05 00	M..
	ld	de,fcb1		; 0c31  11 3c 0c	.<.
	ld	c,13h		; 0c34  0e 13		..
	call	X0005		; 0c36  cd 05 00	M..
	jp	X0000		; 0c39  c3 00 00	C..
;
fcb1:	db	0					; 0c3c .
	db	'$$$     SUB'				; 0c3d
	db	0					; 0c48 .
;
	org	0c62h
;
fcb2:	db	1					; 0c62 .
	db	'$$$     SUB'				; 0c63
	db	0					; 0c6e .
;
	org	0c88h
;
X0c88:	di			; 0c88  f3		s
	ld	sp,stack	; 0c89  31 00 43	1.C
	ld	a,50h		; 0c8c  3e 50		>P
	out	(0ech),a	; 0c8e  d3 ec		Sl
	ld	a,3		; 0c90  3e 03		>.
	out	(84h),a		; 0c92  d3 84		S.
	xor	a		; 0c94  af		/
	out	(0e0h),a	; 0c95  d3 e0		S`
	out	(wdsdh),a	; 0c97  d3 ce		SN
	ld	a,10h		; 0c99  3e 10		>.
	out	(wdcsr),a	; 0c9b  d3 cf		SO
	ex	(sp),hl		; 0c9d  e3		c
	ex	(sp),hl		; 0c9e  e3		c
X0c9f:	in	a,(wdcsr)	; 0c9f  db cf		[O
	rlca			; 0ca1  07		.
	jr	c,X0c9f		; 0ca2  38 fb		8{
	ld	a,70h		; 0ca4  3e 70		>p
	out	(wdcsr),a	; 0ca6  d3 cf		SO
	ex	(sp),hl		; 0ca8  e3		c
	ex	(sp),hl		; 0ca9  e3		c
X0caa:	in	a,(wdcsr)	; 0caa  db cf		[O
	rlca			; 0cac  07		.
	jr	c,X0caa		; 0cad  38 fb		8{
	ld	a,26h		; 0caf  3e 26		>&
	out	(wderrg),a	; 0cb1  d3 c9		SI
	ld	de,X3002	; 0cb3  11 02 30	..0
	ld	bc,X00c8	; 0cb6  01 c8 00	.H.
	ld	hl,(X437b)	; 0cb9  2a 7b 43	*{C
X0cbc:	ld	a,e		; 0cbc  7b		{
	out	(wdset),a	; 0cbd  d3 cb		SK
	ld	a,20h		; 0cbf  3e 20		> 
	out	(wdcsr),a	; 0cc1  d3 cf		SO
	ex	(sp),hl		; 0cc3  e3		c
	ex	(sp),hl		; 0cc4  e3		c
X0cc5:	in	a,(wdcsr)	; 0cc5  db cf		[O
	rlca			; 0cc7  07		.
	jr	c,X0cc5		; 0cc8  38 fb		8{
	in	a,(wdcsr)	; 0cca  db cf		[O
	and	1		; 0ccc  e6 01		f.
	jr	nz,X0d25	; 0cce  20 55		 U
	inir			; 0cd0  ed b2		m2
	inc	e		; 0cd2  1c		.
	ld	a,e		; 0cd3  7b		{
	cp	21h		; 0cd4  fe 21		~!
	jr	nz,X0cdd	; 0cd6  20 05		 .
	ld	e,1		; 0cd8  1e 01		..
	ld	a,e		; 0cda  7b		{
	out	(0cch),a	; 0cdb  d3 cc		SL
X0cdd:	dec	d		; 0cdd  15		.
	jr	nz,X0cbc	; 0cde  20 dc		 \
	ld	bc,X436f	; 0ce0  01 6f 43	.oC
	ld	hl,(X437b)	; 0ce3  2a 7b 43	*{C
	push	hl		; 0ce6  e5		e
	inc	hl		; 0ce7  23		#
	ld	e,(hl)		; 0ce8  5e		^
	ld	(hl),c		; 0ce9  71		q
	inc	hl		; 0cea  23		#
	ld	d,(hl)		; 0ceb  56		V
	ld	(hl),b		; 0cec  70		p
	ld	(X437b),de	; 0ced  ed 53 7b 43	mS{C
	pop	hl		; 0cf1  e1		a
	ld	bc,X1600	; 0cf2  01 00 16	...
	add	hl,bc		; 0cf5  09		.
	jp	(hl)		; 0cf6  e9		i
;
	ld	de,X0000	; 0cf7  11 00 00	...
	ld	hl,X437d	; 0cfa  21 7d 43	!}C
	ld	bc,X0020	; 0cfd  01 20 00	. .
	ldir			; 0d00  ed b0		m0
	jp	X0000		; 0d02  c3 00 00	C..
;
fcb0:	db	0					; 0d05 .
X0d06:	db	0,0,0,0,0,0,0,0				; 0d06 ........
	db	0,0,0,0,0,0,0,0				; 0d0e ........
	db	0,0,0,0,0,0,0,0				; 0d16 ........
	db	0,0,0,0,0,0,0				; 0d1e .......
;
X0d25:	ld	a,2		; 0d25  3e 02		>.
	out	(84h),a		; 0d27  d3 84		S.
	ld	hl,X43ae	; 0d29  21 ae 43	!.C
	ld	de,video	; 0d2c  11 00 f8	..x
	ld	bc,X0015	; 0d2f  01 15 00	...
	ldir			; 0d32  ed b0		m0
X0d34:	jr	X0d34		; 0d34  18 fe		.~
;
	db	'Hard Disk BOOT ERROR!'			; 0d36
	db	0					; 0d4b .
;
	nop			; 0d4c  00		.	; data truncated
;
	org	0d88h
;
seldsk:	jp	seldsk		; 0d88  c3 88 0d	C..
;
settrk:	jp	settrk		; 0d8b  c3 8b 0d	C..
;
setsec:	jp	setsec		; 0d8e  c3 8e 0d	C..
;
setdma:	jp	setdma		; 0d91  c3 91 0d	C..
;
read:	jp	read		; 0d94  c3 94 0d	C..
;
write:	jp	write		; 0d97  c3 97 0d	C..
;
print:	ld	a,(hl)		; 0d9a  7e		~
	inc	hl		; 0d9b  23		#
	or	a		; 0d9c  b7		7
	ret	z		; 0d9d  c8		H
	call	chrout		; 0d9e  cd a3 0d	M#.
	jr	print		; 0da1  18 f7		.w
;
chrout:	push	bc		; 0da3  c5		E
	push	de		; 0da4  d5		U
	push	hl		; 0da5  e5		e
	ld	c,2		; 0da6  0e 02		..
	ld	e,a		; 0da8  5f		_
	call	X0005		; 0da9  cd 05 00	M..
	pop	hl		; 0dac  e1		a
	pop	de		; 0dad  d1		Q
	pop	bc		; 0dae  c1		A
	ret			; 0daf  c9		I
;
X0db0:	ld	de,X0000	; 0db0  11 00 00	...
X0db3:	ld	a,(hl)		; 0db3  7e		~
	sub	30h		; 0db4  d6 30		V0
	jr	c,X0dce		; 0db6  38 16		8.
	cp	0ah		; 0db8  fe 0a		~.
	jr	nc,X0dce	; 0dba  30 12		0.
	inc	hl		; 0dbc  23		#
	push	hl		; 0dbd  e5		e
	ld	l,a		; 0dbe  6f		o
	ld	h,0		; 0dbf  26 00		&.
	push	hl		; 0dc1  e5		e
	ld	h,d		; 0dc2  62		b
	ld	l,e		; 0dc3  6b		k
	add	hl,hl		; 0dc4  29		)
	add	hl,hl		; 0dc5  29		)
	add	hl,de		; 0dc6  19		.
	add	hl,hl		; 0dc7  29		)
	pop	de		; 0dc8  d1		Q
	add	hl,de		; 0dc9  19		.
	ex	de,hl		; 0dca  eb		k
	pop	hl		; 0dcb  e1		a
	jr	X0db3		; 0dcc  18 e5		.e
;
X0dce:	ld	a,d		; 0dce  7a		z
	or	a		; 0dcf  b7		7
	ret			; 0dd0  c9		I
;
imemsg:	db	7,0dh,0ah,0ah				; 0dd1 ....
	db	'Insufficient memory for Hard Dis'	; 0dd5
	db	'k Driver!'				; 0df5
	db	0dh,0ah,0				; 0dfe ...
nonmsg:	db	7,0dh,0ah,0ah				; 0e01 ....
	db	'Hard Disk Driver already initial'	; 0e05
	db	'ized!'					; 0e25
	db	0dh,0ah,0ah,0				; 0e2a ....
idamsg:	db	7,0dh,0ah,0ah				; 0e2e ....
	db	'Illegal drive assignment!'		; 0e32
	db	0dh,0ah,0				; 0e4b ...
permsg:	db	7,0dh,0ah,0ah				; 0e4e ....
	db	'Parameter missing or in error!'	; 0e52
	db	0dh,0ah,0ah,0				; 0e70 ....
ndfmsg:	db	7,0dh,0ah,0ah				; 0e74 ....
	db	'Drive A: has not been defined!'	; 0e78
	db	0dh,0ah,0				; 0e96 ...
nrmsg:	db	7,0dh,0ah,0ah				; 0e99 ....
	db	'The hard disk drive is not ready'	; 0e9d
	db	'!'					; 0ebd
	db	0dh,0ah,0ah,0				; 0ebe ....
fmtmsg:	db	1ah,16h,15h,0dh,0ah			; 0ec2 .....
	db	'    Format 10 Megabyte Hard Disk'	; 0ec7
	db	' Drive'				; 0ee7
	db	15h,0dh,0ah,15h,16h,0dh,0ah,0ah		; 0eed ........
	db	0ah,7					; 0ef5 ..
	db	'>>--> Warning! <--<<'			; 0ef7
	db	0dh,0ah					; 0f0b ..
	db	'Formatting CP/M hard disk drives'	; 0f0d
	db	' will *DESTROY* all data on them'	; 0f2d
	db	'.'					; 0f4d
	db	0dh,0ah					; 0f4e ..
	db	'Type [ Y ] to proceed, any other'	; 0f50
	db	' key to abort:  [   ]'			; 0f70
	db	8,8,8,0					; 0f85 ....
ftrkms:	db	'Y'					; 0f89
	db	0dh,0ah,0ah				; 0f8a ...
	db	'Enter known flawed tracks one at'	; 0f8d
	db	' a time as PHY. DRIVE #,HEAD,TRA'	; 0fad
	db	'CK <ENTER>.'				; 0fcd
	db	0dh,0ah					; 0fd8 ..
	db	'Push <ENTER> alone when done.'		; 0fda
	db	0dh,0ah,0ah,0				; 0ff7 ....
nftmsg:	db	0dh,0ah					; 0ffb ..
	db	'Next flaw D,H,T or <ENTER>:  '		; 0ffd
	db	0					; 101a .
peemsg:	db	0dh,0ah					; 101b ..
	db	'  Previous entry in error - igno'	; 101d
	db	'red!'					; 103d
	db	7,0dh,0ah,0ah,0				; 1041 .....
fmtdms:	db	0dh,0ah,0ah,0ah				; 1046 ....
	db	'Formatting drive '			; 104a
dnum:	db	'X: track      '			; 105b
tnum:	db	8,8,8,8,8				; 1069 .....
tnum1:	db	'   '					; 106e
tnum2:	db	'  '					; 1071
	db	0					; 1073 .
vrfmsg:	db	0dh,0ah					; 1074 ..
	db	'          Verifying track      '	; 1076
	db	0					; 1095 .
wptmsg:	db	7,0dh,0ah,0ah				; 1096 ....
	db	'The hard disk drive is write-pro'	; 109a
	db	'tected -- INIT aborted!'		; 10ba
	db	0dh,0ah,0ah,0				; 10d1 ....
fermsg:	db	0dh,0ah,0ah				; 10d5 ...
	db	'Error during disk format -- INIT'	; 10d8
	db	' aborted!'				; 10f8
	db	0dh,0ah,0ah,0				; 1101 ....
bstmsg:	db	7,0dh,0ah,0ah				; 1105 ....
	db	'>>--> WARNING <--<<'			; 1109
	db	0dh,0ah					; 111c ..
	db	'Bad tracks exist in system areas'	; 111e
	db	' of this drive. They cannot be l'	; 113e
	db	'ocked out '				; 115e
	db	0dh,0ah					; 1168 ..
	db	'and may cause unreliable operati'	; 116a
	db	'on. Use this drive at your own r'	; 118a
	db	'isk!'					; 11aa
	db	0dh,0ah,0ah,0				; 11ae ....
X11b2:	db	7,0dh,0ah,0ah				; 11b2 ....
	db	'Unable to initialize system area'	; 11b6
	db	's of hard disk drive A: --'		; 11d6
	db	0dh,0ah,0				; 11f0 ...
donems:	db	'  Returning to original configur'	; 11f3
	db	'ation.'				; 1213
	db	0dh,0ah,0ah,0				; 1219 ....
X121d:	db	0					; 121d .
X121e:	db	0					; 121e .
biosend:
	dw	X0000		; 121f   00 00      ..
;
X1221:	db	0,0					; 1221 ..
X1223:	db	0,0					; 1223 ..
X1225:	db	78h,5					; 1225 x.
X1227:	db	0,0					; 1227 ..
X1229:	db	0					; 1229 .
X122a:	db	0eah,14h				; 122a j.
X122c:	db	0					; 122c .
X122d:	db	0,0					; 122d ..
X122f:	db	0					; 122f .
X1230:	db	0					; 1230 .
X1231:	db	0					; 1231 .
badtkm:	db	0fh					; 1232 .
	db	'BADTRACK'				; 1233
	db	'T'+80h,'B'+80h				; 123b TB
	db	'L'					; 123d
X123e:	db	0,0,0,0,0,0,0,0				; 123e ........
	db	0,0,0,0,0,0,0,0				; 1246 ........
	db	0,0,0,0					; 124e ....
X1252:	db	0,0,0,0					; 1252 ....
X1256:	db	0					; 1256 .
;
;	Label equates
;  These are labels in the control file that reference
;  the middle of a multibyte instruction or reference
;  an address outside the initialized space
;
dma	equ	80h
buffer	equ	12eah
stack	equ	4300h
video	equ	0f800h
;
;	Symbol equates
;  These are symbols from the control
;  file that are referenced in the code
;
wpreg	equ	0c0h
htdtl	equ	0c1h
wddata	equ	0c8h
wderrg	equ	0c9h
wdscnt	equ	0cah
wdset	equ	0cbh
wdcylh	equ	0cdh
wdsdh	equ	0ceh
wdcsr	equ	0cfh
;
;	miscellaneous equates
;
;  these are addresses referenced in the code but
;  which are in the middle of a multibyte instruction
;  or are addresses outside the initialized space
;
X0000	equ	0
X0001	equ	1
X0005	equ	5
X0006	equ	6
X0007	equ	7
X0008	equ	8
X000a	equ	0ah
X0010	equ	10h
X0015	equ	15h
X0018	equ	18h
X0020	equ	20h
X0081	equ	81h
X0082	equ	82h
X00b0	equ	0b0h
X00c0	equ	0c0h
X00c8	equ	0c8h
X00ff	equ	0ffh
X04c3	equ	4c3h
X04c8	equ	4c8h
X04ca	equ	4cah
X04e7	equ	4e7h
X04f0	equ	4f0h
X04ff	equ	4ffh
X0507	equ	507h
X059e	equ	59eh
X064e	equ	64eh
X06fe	equ	6feh
X07ae	equ	7aeh
X0cf8	equ	0cf8h
X0d03	equ	0d03h
X1220	equ	1220h
X12eb	equ	12ebh
X13ea	equ	13eah
X14ea	equ	14eah
X15fd	equ	15fdh
X1600	equ	1600h
X3002	equ	3002h
X3101	equ	3101h
X436f	equ	436fh
X437b	equ	437bh
X437d	equ	437dh
X43ae	equ	43aeh
X8000	equ	8000h
;
	end
;

